<?php
if (!defined('ABSPATH')) {
	exit;
}
/**
 * 
 *
 *
 * @author   Casso Team
 * @since    
 *
 */

require_once('class-casso-base.php');
class WC_Gateway_Casso_Momo extends WC_Base_Casso
{
	public function __construct()
	{
		$this->bank_id                 = 'momo';
		$this->bank_name		  = 	__('Momo Wallet', 'casso-wordpress-plugin');;

		// $this->icon               = apply_filters('woocommerce_payleo_icon', plugins_url('../assets/momo.png', __FILE__));
		$this->has_fields         = false;
		$this->method_title       = __('Scan code Momo', 'casso-wordpress-plugin');
		$this->method_description = __('Make payment by money transfer via momo. The system automatically confirms the order payment after the transfer is completed', 'casso-wordpress-plugin');
		$this->title        = __('Payment Momo', 'casso-wordpress-plugin');
		parent::__construct();
	}
	public function configure_payment()
	{
		$this->method_title       = __('Payment Momo', 'casso-wordpress-plugin');
		$this->method_description = __('Make payment by bank transfer via Momo.', 'casso-wordpress-plugin');
	}

	public function thankyou_page($order_id)
	{
		if ($this->instructions) {
			echo wp_kses_post(wpautop(wptexturize(wp_kses_post($this->instructions))));
		}
		global $wp_session;
		if (!isset($wp_session['tmp'])) {
			$wp_session['tmp'] = true;
		} else {
			$this->momo_details($order_id);
		}
	}
	private function momo_details($order_id = '')
	{
		if (empty($this->account_details)) {
			return;
		}
		// Get order and store in $order.
		$order = wc_get_order($order_id);
		$to = $order->get_billing_email();
		$subject = 'Thanh Toán đơn hàng';
		// Get the order country and country $locale.
		$country = $order->get_billing_country();
		$locale  = $this->get_country_locale();
		// Get sortcode label in the $locale array and use appropriate one.
		$sortcode = isset($locale[$country]['sortcode']['label']) ? $locale[$country]['sortcode']['label'] : __('Sort code', 'woocommerce');
		$bacs_accounts = $this->account_details; //apply_filters( 'woocommerce_bacs_accounts', $this->account_details, $order_id );

		if (!empty($bacs_accounts)) {
			$account_html = '';
			$has_details  = false;

			foreach ($bacs_accounts as $bacs_account) {
				$bacs_account = (object) $bacs_account;

				if ($bacs_account->account_name) {
					$account_html .= '<h3 class="wc-bacs-bank-details-account-name"></h3>' . PHP_EOL;
				}
				$account_html .= '<ul class="wc-bacs-bank-details order_details bacs_details">' . PHP_EOL;
				// BACS account fields shown on the thanks page and in emails.
				$account_fields = apply_filters(
					'woocommerce_bacs_account_fields',
					array(
						'bank_name'      => array(
							'label' => __('Bank', 'woocommerce'),
							'value' => $bacs_account->bank_name,
						),
						'account_number' => array(
							'label' => __('Account number', 'woocommerce'),
							'value' => $bacs_account->account_number,
						),
						'account_name' => array(
							'label' => __('Account name', 'woocommerce'),
							'value' => $bacs_account->account_name,
						),
						'amount'            => array(
							'label' => __('Amount', 'casso-wordpress-plugin'),
							'value' => number_format($order->get_total(), 0),
						),
						'content'            => array(
							'label' => __('Content', 'casso-wordpress-plugin'),
							'value' =>	$this->casso_plugin_settings['bank_transfer']['transaction_prefix'] . '' . $order_id,
						),
					),
					$order_id
				);

				$url = 'https://nhantien.momo.vn/' . $account_fields['account_number']['value'] . '/' . ceil($order->get_total());
				$momo_url_sdk = $this->get_momo_pay_url($url);
				foreach ($account_fields as $field_key => $field) {
					if (!empty($field['value'])) {

						if ($field['label'] == 'Ngân hàng' || $field['label'] == 'Bank') $field['label'] = __('Wallet', 'casso-wordpress-plugin');
						if ($field['label'] == 'Số tài khoản' || $field['label'] == 'Account number') $field['label'] =  __('Phone number', 'casso-wordpress-plugin');
						if ($field['value'] == 'momo') $field['value'] = 'Momo';
						$account_html .= '<li class="' . esc_attr($field_key) . '">' . wp_kses_post($field['label']) . ': <strong style="color:#15ab64!important">' . wp_kses_post(wptexturize($field['value'])) . '</strong></li>' . PHP_EOL;
						$has_details   = true;
					}
				}
				$account_html .= '</ul>';

				//$account_html .= '<h6 class="wc-bacs-bank-details-account-name" style="padding: 8px 16px;background: #66ff999e;color:#333;margin-top:16px">' . sprintf(__("Please transfer the correct content <b>%s%s</b> for the system to automatically confirm the payment.</h6>",'casso-wordpress-plugin'),$this->casso_plugin_settings['bank_transfer']['transaction_prefix'],$order_id) . PHP_EOL;
				if ($has_details) {
					echo '

					<section class="woocommerce-casso-wordpress-plugin-qr-scan">

					<!-- QR TTILE-->
					<h2 class="wc-casso-wordpress-plugin-bank-details-heading" style="text-align: center; margin-top: 20px">' . __('Bank transfer QR code', 'casso-wordpress-plugin')  . '</h2>
		
					
					<!-- QR IMAGE HERE-->
					<div style="">
						<div id="qrcode" style="text-align: center;">
						</div>	
					</div>	
					</section>

					<div class="alert alert-warning"><h4 style="color: #856404; max-width: 750px; margin: auto; margin-bottom: 30px; margin-top: 30px; background-color: #ffeeba; padding: 15px; border-radius: 7px;">' .  sprintf(__("Please transfer the correct content <b style='font-size: 20px;'>%s</b> for we can confirm the payment", 'casso-wordpress-plugin'), esc_html($this->casso_plugin_settings['bank_transfer']['transaction_prefix'] . '' . $order_id)) . '</h4></div>

					<!-- BANK DETAIL INFO TABLE-->
				<table class="table table-bordered" style="font-size: 15px;max-width: 800px;margin-left: auto;margin-right: auto;">
				<tbody>
				<tr class="" >
						<td class="text-right"  style="text-align: right;">
							<strong style="color: black;">' . __('Account name', 'woocommerce') . ':</strong>
							<br>
						</td>
						<td class="text-left payment-instruction" style="text-align: left;">
							<div>
								<span style="color: black;">' . esc_html($account_fields['account_name']['value']) . '</span>
								<br>
							</div>
						</td>
					</tr>
					<tr class="" style="background-color:#FBFBFB;">
						<td class="text-right"  style="text-align: right;">
							<strong style="color: black;">' . __('Account number', 'casso-wordpress-plugin') . ':</strong>
						</td>
						<td class="text-left payment-instruction" style="text-align: left;">
							<span style="color: black;">' . esc_html($account_fields['account_number']['value']) . '</span>
						</td>
					</tr>
					<tr class="" style="">
						<td class="text-right" style="text-align: right;">
							<strong style="color: black;">' . __('Bank', 'casso-wordpress-plugin') . ':</strong>
							<br>
						</td>
						<td class="text-left payment-instruction" style="text-align: left;">
							<div>
								<span style="color: black;">' . esc_html($account_fields['bank_name']['value']) . '</span>
								<br>
							</div>
						</td>
					</tr>
					<tr class="" style="">
						<td class="text-right"  style="text-align: right;">
							<strong style="color: black;">' . __('Amount', 'casso-wordpress-plugin') . ':</strong>
							<br>
						</td>
						<td class="text-left payment-instruction" style="text-align: left;">
							<div ng-switch-when="vcb" class="ng-scope">
								<span style="color: black;">' . esc_html($account_fields['amount']['value']) . ' <sup>vnđ</sup></span>
								<br>
							</div>
						</td>
					</tr>
					<tr class="" >
						<td class="text-right" style="text-align: right;">
							<strong style="color: black;">' . __('Content', 'casso-wordpress-plugin') . '*:</strong>
						</td>
						<td class="text-left payment-instruction" style="text-align: left;">
							<strong style="font-size: 20px;">
							' . esc_html($account_fields['content']['value']) . '
							</strong>
						</td>
					</tr>
				</tbody>
				</table>
				<center style="margin-top: 20px;font-size: 15px;">
				<form method="post" id = "form-submit-pay">
				<input name="bank_id" type="hidden" value="' . $account_fields['account_number']['value'] . '">
				<input name="order_id" type="hidden" value="' . $order_id . '">
				
				<img src="https://drandreadinardo.files.wordpress.com/2017/09/img_2370.gif?w=347"  style = "width: 100px; display:none;" id ="image_loading"/>
				<input type="submit" name="submit_paid" id="input_casso" style="margin-bottom: 20px;"
				class="button1" value="Tôi đã thanh toán"/>
				<img src="https://wpamelia.com/wp-content/uploads/2018/11/ezgif-2-6d0b072c3d3f.gif" style = "display:none"  alt="casso-wordpress-plugin QR Image" width="300px" id ="image_loading"/>
				</form>
				</center>
			</section>

			<!-- STYLE CSS-->
			<script>
			window.addEventListener("load", function() {
				document.getElementById("form-submit-pay").addEventListener("submit", function(e) {
				  document.getElementById("image_loading").style.display = "block";
				})
			  });
			</script>
			<style>
			  	#image_loading{
			
					margin-left: auto;
					margin-right: auto;
					width: 35%;  
				}


				#btnDownloadQR{
					width:100%;
					border-radius: 0;
					padding-left: 10px !important;
					padding-right: 10px !important;
					border-color: #0274be;
    				background-color: #0274be;
					color: #ffffff;
					line-height: 1;
				}

				td{
					width: 25% ;
				}
				#qrcode canvas {
					border: 2px solid #ccc;
					padding: 20px;
				
				}
				.woocommerce-casso-wordpress-plugin-qr-scan{
					text-align: center;
					margin-top: 0px;
				}
				.woocommerce-casso-wordpress-plugin-bank-details{
					text-align: center;
					margin-top: 10px;
				}
	
			</style>
            <center>	
				<script type="text/javascript">
				setTimeout(function(){ var qrcode = new QRCode(document.getElementById("qrcode"), {
					text: "' . $momo_url_sdk . '",
					width: 256,
					height: 256,
					logo: "https://img.mservice.io/momo-payment/icon/images/logo512.png",
					logoWidth: 50,
					logoHeight: 50,
					logoBackgroundColor: "#ffffff",
					logoBackgroundTransparent: false
				}); }, 0);	
				</script>
				<style>
				td{
					width: 25% ;
				}
				#qrcode canvas {
					border: 2px solid #ccc;
					padding: 20px;
				
				}
				</style>
				</section>';
				}
			}
		}
	}


	public function console_log($output, $with_script_tags = true)
	{
		$js_code = 'console.log(' . json_encode($output, JSON_HEX_TAG) .
			');';
		if ($with_script_tags) {
			$js_code = '<script>' . $js_code . '</script>';
		}
		echo $js_code;
	}
	public function get_momo_pay_url($url)
	{
		$re = '/(?:(?:https?):\/\/momosdk.page.link)(?:\([-A-Z0-9+&@#\/%=~_|$?!:,.]*\)|[-A-Z0-9+&@#\/%=~_|$?!:,.])*(?:\([-A-Z0-9+&@#\/%=~_|$?!:,.]*\)|[A-Z0-9+&@#\/%=~_|$])/im';
		$response = wp_remote_get($url, array(
			'headers' => array(
				"content-type" => "application/json",
				"User-Agent" => "Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1; SV1)"
			)
		));
		$body     = wp_remote_retrieve_body($response);
		preg_match_all($re, $body, $matches, PREG_SET_ORDER, 0);
		return $matches[0][0];
	}
}
